/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package pos.dialog;

import com.ustasoft.component.GeneralFunction;
import com.ustasoft.pos.dao.jdbc.ArInvDao;
import com.ustasoft.pos.dao.jdbc.SalesDao;
import com.ustasoft.pos.domain.ArInv;
import com.ustasoft.pos.domain.Sales;
import java.awt.Color;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFormattedTextField;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import org.jdesktop.swingx.JXDatePicker;
import pos.MainForm;
import pos.ar.FrmSaldoAwalAR;

/**
 *
 * @author cak-ust
 */
public class DlgSaldoAwalAr extends javax.swing.JDialog {
    private GeneralFunction fn=new GeneralFunction();
    ArInv ar=new ArInv();
    private int idRelasi;
    ArInvDao dao=new ArInvDao();
    private Connection conn;
    private List<Sales> salesman;
    private Object srcForm;
    private Integer arId;
    /**
     * Creates new form DlgSaldoAwalApAr
     */
    public DlgSaldoAwalAr(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        jXDatePicker1.setFormats(MainForm.sDateFormat);
        jXDatePicker1.addFocusListener(txtFocusListener);
        txtJumlah.addFocusListener(txtFocusListener);
        txtNoInvoice.addFocusListener(txtFocusListener);
        txtTop.addFocusListener(txtFocusListener);
        
    }

    private void setDueDate(){
        lblJthTempo.setText(new SimpleDateFormat("dd/MM/yyyy").format(
                getDueDate(jXDatePicker1.getDate(),
                fn.udfGetInt(txtTop.getText()))));
    }
    
    private Date getDueDate(Date d, int i){
        Calendar c = Calendar.getInstance();
        c.setTime(d);
        c.add(Calendar.DAY_OF_MONTH, i);

        return c.getTime();
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        lblRelasi = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        txtNoInvoice = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jXDatePicker1 = new org.jdesktop.swingx.JXDatePicker();
        lblJthTempo = new javax.swing.JLabel();
        txtTop = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        txtJumlah = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        btnSave = new javax.swing.JButton();
        btnCancel = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JSeparator();
        cmbSales = new javax.swing.JComboBox();
        jLabel17 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowOpened(java.awt.event.WindowEvent evt) {
                formWindowOpened(evt);
            }
        });
        getContentPane().setLayout(null);

        jLabel1.setText("Tgl. Invoice :");
        getContentPane().add(jLabel1);
        jLabel1.setBounds(15, 70, 75, 23);

        lblRelasi.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        getContentPane().add(lblRelasi);
        lblRelasi.setBounds(95, 15, 420, 23);

        jLabel2.setText("Relasi : ");
        getContentPane().add(jLabel2);
        jLabel2.setBounds(15, 15, 75, 23);
        getContentPane().add(txtNoInvoice);
        txtNoInvoice.setBounds(95, 40, 140, 25);

        jLabel3.setText("No. Invoice :");
        getContentPane().add(jLabel3);
        jLabel3.setBounds(15, 40, 75, 23);

        jXDatePicker1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jXDatePicker1ActionPerformed(evt);
            }
        });
        getContentPane().add(jXDatePicker1);
        jXDatePicker1.setBounds(95, 70, 150, 24);

        lblJthTempo.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        getContentPane().add(lblJthTempo);
        lblJthTempo.setBounds(390, 70, 130, 23);

        txtTop.setText("30");
        getContentPane().add(txtTop);
        txtTop.setBounds(390, 40, 50, 25);

        jLabel5.setText(" Hari");
        getContentPane().add(jLabel5);
        jLabel5.setBounds(440, 40, 40, 23);

        jLabel6.setText("Tgl. Jth Tempo : ");
        getContentPane().add(jLabel6);
        jLabel6.setBounds(265, 70, 130, 23);

        jLabel7.setText("Jumlah :");
        getContentPane().add(jLabel7);
        jLabel7.setBounds(15, 95, 75, 23);

        txtJumlah.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        txtJumlah.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                txtJumlahKeyPressed(evt);
            }
            public void keyTyped(java.awt.event.KeyEvent evt) {
                txtJumlahKeyTyped(evt);
            }
        });
        getContentPane().add(txtJumlah);
        txtJumlah.setBounds(95, 95, 140, 25);

        jLabel8.setText("Termin : ");
        getContentPane().add(jLabel8);
        jLabel8.setBounds(265, 40, 70, 23);

        btnSave.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/images/accept.png"))); // NOI18N
        btnSave.setText("Simpan");
        btnSave.setFocusable(false);
        btnSave.setMargin(new java.awt.Insets(2, 2, 2, 2));
        btnSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSaveActionPerformed(evt);
            }
        });
        getContentPane().add(btnSave);
        btnSave.setBounds(325, 190, 80, 30);

        btnCancel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/images/cancel.png"))); // NOI18N
        btnCancel.setText("Batal");
        btnCancel.setFocusable(false);
        btnCancel.setMargin(new java.awt.Insets(2, 2, 2, 2));
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelActionPerformed(evt);
            }
        });
        getContentPane().add(btnCancel);
        btnCancel.setBounds(410, 190, 90, 30);
        getContentPane().add(jSeparator1);
        jSeparator1.setBounds(95, 170, 395, 10);

        cmbSales.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        getContentPane().add(cmbSales);
        cmbSales.setBounds(95, 125, 325, 22);

        jLabel17.setText("Salesman :");
        getContentPane().add(jLabel17);
        jLabel17.setBounds(15, 125, 75, 20);

        setSize(new java.awt.Dimension(558, 270));
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void btnSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSaveActionPerformed
        if(!udfCekBeforeSave())
            return;
        ar.setId(arId);
        ar.setCustomerId(idRelasi);
        ar.setInvoiceNo(txtNoInvoice.getText());
        ar.setInvoiceDate(jXDatePicker1.getDate());
        ar.setTop(GeneralFunction.udfGetInt(txtTop.getText()));
        ar.setInvoiceAmount(fn.udfGetDouble(txtJumlah.getText()));
        ar.setItemAmount(fn.udfGetDouble(txtJumlah.getText()));
        ar.setOwing(fn.udfGetDouble(txtJumlah.getText()));
        ar.setPaidAmount(new Double(0));
        ar.setTrxType("SAR");
        ar.setJenisBayar("K");
        ar.setIdGudang(new Integer(1));
        ar.setIdSales(salesman.get(cmbSales.getSelectedIndex()).getId_sales());
        try {
            dao.simpanHeader(ar);
            JOptionPane.showMessageDialog(this, arId ==null? "Simpan": "Update" +" Saldo Awal Sukses!");
            if(srcForm instanceof FrmSaldoAwalAR){
                ((FrmSaldoAwalAR)srcForm).udfLoadSaldoAwal();
            }
            this.dispose();
        } catch (SQLException ex) {
            Logger.getLogger(DlgSaldoAwalAr.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_btnSaveActionPerformed

    private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelActionPerformed
        this.dispose();
    }//GEN-LAST:event_btnCancelActionPerformed

    private void txtJumlahKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtJumlahKeyPressed
        // TODO add your handling code here:
    }//GEN-LAST:event_txtJumlahKeyPressed

    private void txtJumlahKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtJumlahKeyTyped
        fn.keyTyped(evt);
    }//GEN-LAST:event_txtJumlahKeyTyped

    private void jXDatePicker1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jXDatePicker1ActionPerformed
        setDueDate();
    }//GEN-LAST:event_jXDatePicker1ActionPerformed

    private void formWindowOpened(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
        try {
            cmbSales.removeAllItems();
            salesman=new SalesDao(conn).cariSemuaData();
            for(Sales s : salesman){
                cmbSales.addItem(s.getNama_sales());
            }
            if(arId!=null){
                String sql="select h.invoice_no, h.id_customer, coalesce(c.nama_relasi,'') as nama, "
                        + "h.invoice_date, h.top, to_Char(h.invoice_date+h.top, 'dd/MM/yyyy') as jth_tempo, \n" +
                            "h.invoice_amount, coalesce(s.nama_sales,'') as nama_sales\n" +
                            "from ar_inv h \n" +
                            "left join m_relasi c on c.id_relasi=h.id_customer\n" +
                            "left join m_salesman s on s.id_sales=h.id_sales\n" +
                            "where id="+arId;
                ResultSet rs=conn.createStatement().executeQuery(sql);
                if(rs.next()){
                    idRelasi=rs.getInt("id_customer");
                    lblRelasi.setText(rs.getString("nama"));
                    txtNoInvoice.setText(rs.getString("invoice_no"));
                    jXDatePicker1.setDate(rs.getDate("invoice_date"));
                    txtTop.setText(rs.getString("top"));
                    lblJthTempo.setText(rs.getString("jth_tempo"));
                    txtJumlah.setText(GeneralFunction.intFmt.format(rs.getDouble("invoice_amount")));
                    cmbSales.setSelectedItem(rs.getString("nama_sales"));
                }
                rs.close();
            }
        } catch (Exception ex) {
            Logger.getLogger(DlgSaldoAwalAr.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_formWindowOpened

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(DlgSaldoAwalAr.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(DlgSaldoAwalAr.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(DlgSaldoAwalAr.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(DlgSaldoAwalAr.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                DlgSaldoAwalAr dialog = new DlgSaldoAwalAr(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnCancel;
    private javax.swing.JButton btnSave;
    private javax.swing.JComboBox cmbSales;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JSeparator jSeparator1;
    private org.jdesktop.swingx.JXDatePicker jXDatePicker1;
    private javax.swing.JLabel lblJthTempo;
    private javax.swing.JLabel lblRelasi;
    private javax.swing.JTextField txtJumlah;
    private javax.swing.JTextField txtNoInvoice;
    private javax.swing.JTextField txtTop;
    // End of variables declaration//GEN-END:variables

    public void setRelasi(int id, String text, int top) {
        this.idRelasi=id;
        lblRelasi.setText(text);
        txtTop.setText(GeneralFunction.intFmt.format(top));
        setDueDate();
    }

    public void setConn(Connection conn) {
        this.conn=conn;
        dao.setConn(conn);
    }
    
    private FocusListener txtFocusListener=new FocusListener() {
        public void focusGained(FocusEvent e) {
            if(e.getSource() instanceof JTextField || e.getSource() instanceof JFormattedTextField ){
                ((JTextField)e.getSource()).setBackground(Color.YELLOW);
                if( (e.getSource() instanceof JTextField && ((JTextField)e.getSource()).getName()!=null && ((JTextField)e.getSource()).getName().equalsIgnoreCase("textEditor"))){
                    ((JTextField)e.getSource()).setSelectionStart(0);
                    ((JTextField)e.getSource()).setSelectionEnd(((JTextField)e.getSource()).getText().length());

                }
            }else if(e.getSource() instanceof JXDatePicker){
                ((JXDatePicker)e.getSource()).setBackground(Color.YELLOW);
            }
        }


        public void focusLost(FocusEvent e) {
            if(e.getSource() instanceof  JTextField||e.getSource() instanceof JFormattedTextField){
                ((JTextField)e.getSource()).setBackground(Color.WHITE);
                if(e.getSource().equals(txtTop))
                    setDueDate();
                else if(e.getSource().equals(txtJumlah))
                    txtJumlah.setText(GeneralFunction.intFmt.format(GeneralFunction.udfGetDouble(txtJumlah.getText())));
           }
        }
    } ;

    public void setSrcForm(Object aThis) {
        this.srcForm=aThis;
    }

    public void setArId(Integer integer) {
        this.arId=integer;
    }

    private boolean udfCekBeforeSave() {
        btnSave.requestFocus();
        if(lblRelasi.getText().trim().equalsIgnoreCase("")){
            JOptionPane.showMessageDialog(this, "Pelanggan harus terisi!");
            return false;
        }
        if(fn.udfGetDouble(txtJumlah.getText())==0){
            JOptionPane.showMessageDialog(this, "Silahkan isi jumlah piutang terlebih dulu!");
            txtJumlah.requestFocus();
            return false;
        }
        if(arId ==null){
            try {
                ResultSet rs=conn.createStatement().executeQuery("select * from ar_inv where invoice_no='"+txtNoInvoice.getText()+"'");
                if(rs.next()){
                    JOptionPane.showMessageDialog(this, "No. Invoice tersebut sudah pernah digunakan!");
                    txtNoInvoice.requestFocus();
                    return false;
                }
            } catch (SQLException ex) {
                Logger.getLogger(DlgSaldoAwalAp.class.getName()).log(Level.SEVERE, null, ex);
            }
            
        }
        return true;
    }
    
    
}
